﻿using System.Collections.Generic;
using System.Web.Mvc;
using Kreta.BusinessLogic.HelperClasses;
using Kreta.Resources;
using Microsoft.Ajax.Utilities;
using ModelStateDictionary = System.Web.Http.ModelBinding.ModelStateDictionary;

namespace Kreta.Web.Areas.Kerdoiv.Models
{
    public class NatKerdoivModel
    {
        #region Constructors

        public NatKerdoivModel()
        {
        }

        public NatKerdoivModel(NatKerdoivCo co)
        {
            Id = co.Id;
            Kerdes01 = co.Kerdes01;
            Kerdes02 = co.Kerdes02;
            Kerdes03 = co.Kerdes03;
            Kerdes04 = co.Kerdes04;
            Kerdes05 = co.Kerdes05;
            Kerdes06 = co.Kerdes06;
            Kerdes07 = co.Kerdes07;
            Kerdes08 = co.Kerdes08;
            Kerdes09 = co.Kerdes09;
            Kerdes10 = co.Kerdes10;
            Kerdes11 = co.Kerdes11;
            Kerdes12 = co.Kerdes12;
        }

        #endregion Constructors

        #region Properties

        public int? Id { get; set; }
        public int? Kerdes01 { get; set; }
        public int? Kerdes02 { get; set; }
        public int? Kerdes03 { get; set; }
        public int? Kerdes04 { get; set; }
        public int? Kerdes05 { get; set; }
        public int? Kerdes06 { get; set; }
        public int? Kerdes07 { get; set; }
        public int? Kerdes08 { get; set; }
        public int? Kerdes09 { get; set; }
        public int? Kerdes10 { get; set; }
        public string Kerdes11 { get; set; }
        public string Kerdes12 { get; set; }
        public List<SelectListItem> EgyToOtWithNemTudomSelectList { get; set; }

        #endregion Properties

        public NatKerdoivCo ToCo()
        {
            var result = new NatKerdoivCo
            {
                Id = Id,
                Kerdes01 = Kerdes01,
                Kerdes02 = Kerdes02,
                Kerdes03 = Kerdes03,
                Kerdes04 = Kerdes04,
                Kerdes05 = Kerdes05,
                Kerdes06 = Kerdes06,
                Kerdes07 = Kerdes07,
                Kerdes08 = Kerdes08,
                Kerdes09 = Kerdes09,
                Kerdes10 = Kerdes10,
                Kerdes11 = string.IsNullOrWhiteSpace(Kerdes11) ? null : Kerdes11,
                Kerdes12 = string.IsNullOrWhiteSpace(Kerdes12) ? null : Kerdes12
            };
            return result;
        }

        public ModelStateDictionary Validate()
        {
            var modelStateDictionary = new ModelStateDictionary();

            if (!Kerdes11.IsNullOrWhiteSpace() && Kerdes11.Length > 1000)
            {
                modelStateDictionary.AddModelError(nameof(Kerdes11), string.Format(KerdoivResource.AKerdesValaszaNemLehetHosszabbMint1000Karakter, "11"));
            }
            if (!Kerdes12.IsNullOrWhiteSpace() && Kerdes12.Length > 1000)
            {
                modelStateDictionary.AddModelError(nameof(Kerdes12), string.Format(KerdoivResource.AKerdesValaszaNemLehetHosszabbMint1000Karakter, "12"));
            }

            return modelStateDictionary;
        }
    }
}
